using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Security.Permissions;
using UnityEngine;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

            //Wooden Door
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Wooden Door -DM",
                    NameToOrderByOverride = "Door 1",
                    DescriptionOverride = "A functional door made of wood",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("WoodDoorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ClosedWoodDoor.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.1714222f, 2.285714f);
                        Collision1.offset = new Vector2(-0.02857459f, 0f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05714917f, 0.1428615f);
                        Collision2.offset = new Vector2(0.08571112f, -0.04285413f);

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("ClosedWoodDoor.png");
                        Door.B = ModAPI.LoadSprite("OpenWoodDoor.png");

                        /*

                        Code has now been fixed so the doors do not make sounds when spawned

                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("DoorOpeningSound.mp3");
                        Door.audioclipB = ModAPI.LoadSound("DoorCloseSound.mp3");
                        Door.audio = DoorAudio;
                        */
                        

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.75f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.75f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.75f;
                    }
                }
            );

            //Log Door
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Log Door -DM",
                    NameToOrderByOverride = "Door 2",
                    DescriptionOverride = "A functional door made of wood similar to a log.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("LogDoorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ClosedLogDoor.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.1714222f, 2.285714f);
                        Collision1.offset = new Vector2(-0.02857459f, 0f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05714917f, 0.1428615f);
                        Collision2.offset = new Vector2(0.08571112f, -0.04285413f);

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("ClosedLogDoor.png");
                        Door.B = ModAPI.LoadSprite("OpenLogDoor.png");

                        /*
                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("DoorOpeningSound.mp3");
                        Door.audioclipB = ModAPI.LoadSound("DoorCloseSound.mp3");
                        Door.audio = DoorAudio;
                        */

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.9f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.9f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.9f;
                    }
                }
            );

            //Glass Door
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Glass Door -DM",
                    NameToOrderByOverride = "Door 3",
                    DescriptionOverride = "A functional door made of glass",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("GlassDoorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ClosedGlassDoor.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.1714222f, 2.285714f);
                        Collision1.offset = new Vector2(-0.02857459f, 0f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05714917f, 0.1428615f);
                        Collision2.offset = new Vector2(0.08571112f, -0.04285413f);

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Glass");

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("ClosedGlassDoor.png");
                        Door.B = ModAPI.LoadSprite("OpenGlassDoor.png");    

                        /*
                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("DoorOpeningSound.mp3");
                        Door.audioclipB = ModAPI.LoadSound("DoorCloseSound.mp3");
                        Door.audio = DoorAudio;
                        */

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.5f;
                    }
                }
            );

            //Red Metal Door
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Red Metal Door -DM",
                    NameToOrderByOverride = "Door 4",
                    DescriptionOverride = "A functional door made of red metal",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("RedMetalDoorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ClosedRedMetalDoor.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.228569f, 2.285714f);
                        Collision1.offset = new Vector2(-0.02857208f, 0f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05715942f, 0.1428615f);
                        Collision2.offset = new Vector2(0.1142921f, -0.04285413f);

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("ClosedRedMetalDoor.png");
                        Door.B = ModAPI.LoadSprite("OpenRedMetalDoor.png");

                        /*
                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("MetalDoorOpening.mp3");
                        Door.audioclipB = ModAPI.LoadSound("MetalDoorClosing.mp3");
                        Door.audio = DoorAudio;
                        */

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1.5f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 1.5f;
                    }
                }
            );

            //Silver Metal Door
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Silver Metal Door -DM",
                    NameToOrderByOverride = "Door 5",
                    DescriptionOverride = "A functional door made of silver metal",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("SilverMetalDoorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ClosedSilverMetalDoor.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.228569f, 2.285714f);
                        Collision1.offset = new Vector2(-0.02857208f, 0f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05715942f, 0.1428615f);
                        Collision2.offset = new Vector2(0.1142921f, -0.04285413f);

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("ClosedSilverMetalDoor.png");
                        Door.B = ModAPI.LoadSprite("OpenSilverMetalDoor.png");
                        
                        /*
                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("MetalDoorOpening.mp3");
                        Door.audioclipB = ModAPI.LoadSound("MetalDoorClosing.mp3");
                        Door.audio = DoorAudio;
                        */

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass =  1.5f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 1.5f;
                    }
                }
            );

            //Bulletproof Door
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                    NameOverride = "Bulletproof Door -DM",
                    NameToOrderByOverride = "Door 6",
                    DescriptionOverride = "A functional door made of a strong bullet resistant material.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("BulletproofDoorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ClosedSilverMetalDoor.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.228569f, 2.285714f);
                        Collision1.offset = new Vector2(-0.02857208f, 0f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05715942f, 0.1428615f);
                        Collision2.offset = new Vector2(0.1142921f, -0.04285413f);

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("ClosedBulletproofDoor.png");
                        Door.B = ModAPI.LoadSprite("OpenBulletproofDoor.png");

                        /*
                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("MetalDoorOpening.mp3");
                        Door.audioclipB = ModAPI.LoadSound("MetalDoorClosing.mp3");
                        Door.audio = DoorAudio;
                        */

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 2.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass =  2.5f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 2.5f;
                    }
                }
            );

            //Soap Door
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soap"),
                    NameOverride = "Soap Door -DM",
                    NameToOrderByOverride = "Door 7",
                    DescriptionOverride = "A functional door made of soap",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("SoapDoorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ClosedSoapDoor.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.1714222f, 2.285714f);
                        Collision1.offset = new Vector2(-0.02857459f, 0f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05714917f, 0.1428615f);
                        Collision2.offset = new Vector2(0.08571112f, -0.04285413f);

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("ClosedSoapDoor.png");
                        Door.B = ModAPI.LoadSprite("OpenSoapDoor.png");   

                        /*
                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("DoorOpeningSound.mp3");
                        Door.audioclipB = ModAPI.LoadSound("DoorCloseSound.mp3");
                        Door.audio = DoorAudio; 
                        */

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.5f;
                    }
                }
            );

            //Rod Door
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Rod Door -DM",
                    NameToOrderByOverride = "Door 8",
                    DescriptionOverride = "A functional door made of the same material as a rod",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("RodDoorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ClosedRodDoor.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        var Collision1 = Instance.AddComponent<BoxCollider2D>();
                        Collision1.size = new Vector2(0.1428528f, 2.285714f);
                        Collision1.offset = new Vector2(-0.02857208f, 0f);

                        var Collision2 = Instance.AddComponent<BoxCollider2D>();
                        Collision2.size = new Vector2(0.05714035f, 0.1428615f);
                        Collision2.offset = new Vector2(0.0714283f, -0.04285413f);

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                        if(Instance.GetComponent<DoorBehaviour>() == null)
				    	{
				    	    Instance.AddComponent(typeof(DoorBehaviour));
				    	}
                        var Door = Instance.GetComponent<DoorBehaviour>();

                        Door.A = ModAPI.LoadSprite("ClosedRodDoor.png");
                        Door.B = ModAPI.LoadSprite("OpenRodDoor.png");   
 
                        /*
                        AudioSource DoorAudio = Instance.AddComponent(typeof (AudioSource)) as AudioSource;
                        Door.audioclipA = ModAPI.LoadSound("MetalDoorOpening.mp3");
                        Door.audioclipB = ModAPI.LoadSound("MetalDoorClosing.mp3");
                        Door.audio = DoorAudio; 
                        */

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 1f;
                    }
                }
            );
        }
    }
    
   class DoorBehaviour : MonoBehaviour
    {
       private void Start()
       {
           renderer = gameObject.GetComponent<SpriteRenderer>();
           UpdateState();
       }
       void UpdateState()
       {
           if(Activated)
           {
               renderer.sprite = B;
               renderer.sortingLayerName = "Bottom";
               gameObject.layer = 10;
           }
           else
           {
               renderer.sprite = A;
               renderer.sortingLayerName = "Objects";
               gameObject.layer = LayerMask.NameToLayer("Objects");
           }
       }
       private void Use() {
         if (!base.enabled) {
            return;
         }
         /*
         if(Activated)
         {
            audio.PlayOneShot(audioclipB, 1f);
         }
         else
         {
            audio.PlayOneShot(audioclipA, 1f);
         }
         */
         
         SetActivated(!Activated);
      }
      private void SetActivated(bool activated) {
         Activated = activated;
         UpdateState();
      }

      public bool Activated = false;
      [SkipSerialisation]
      public SpriteRenderer renderer;
      [SkipSerialisation]
      public Sprite A;
      [SkipSerialisation]
      public Sprite B;
      /*
      [SkipSerialisation]
      public AudioSource audio;
      [SkipSerialisation]
      public AudioClip audioclipA;
      [SkipSerialisation]
      public AudioClip audioclipB;
      */
   }
}